package cn.skcks.docking.gb28181.wvp.test;

import cn.hutool.crypto.digest.MD5;
import cn.skcks.docking.gb28181.common.json.JsonResponse;
import cn.skcks.docking.gb28181.wvp.config.WvpProxyConfig;
import cn.skcks.docking.gb28181.wvp.dto.device.GetDeviceChannelsReq;
import cn.skcks.docking.gb28181.wvp.dto.device.GetDeviceChannelsResp;
import cn.skcks.docking.gb28181.wvp.dto.device.GetDeviceTreeReq;
import cn.skcks.docking.gb28181.wvp.dto.device.GetDeviceTreeResp;
import cn.skcks.docking.gb28181.wvp.dto.login.WvpLoginReq;
import cn.skcks.docking.gb28181.wvp.dto.login.WvpLoginResp;
import cn.skcks.docking.gb28181.wvp.proxy.WvpProxyClient;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit.jupiter.SpringExtension;

@Slf4j
@SpringBootTest
@EnableAutoConfiguration(exclude={DataSourceAutoConfiguration.class})
@ExtendWith(SpringExtension.class)
public class WvpProxyTest {
    @Autowired
    private WvpProxyClient wvpProxyClient;

    @Autowired
    private WvpProxyConfig config;

    @Test
    void test(){
        String passwdMd5 = MD5.create().digestHex(config.getPasswd());
        WvpLoginReq loginReq = WvpLoginReq.builder()
                .username(config.getUser())
                .password(passwdMd5)
                .build();
        log.info("{}", loginReq);
        JsonResponse<WvpLoginResp> loginResp = wvpProxyClient.login(loginReq);
        log.info("{}", loginResp);

        String token = loginResp.getData().getAccessToken();
        String deviceId = "44050100002000000001";
        GetDeviceTreeReq getDeviceTreeReq = GetDeviceTreeReq.builder().build();
        JsonResponse<GetDeviceTreeResp> deviceTreeResp = wvpProxyClient.getDeviceTree(token, deviceId, getDeviceTreeReq);
        log.info("{}", deviceTreeResp);

        GetDeviceChannelsReq getDeviceChannelsReq = GetDeviceChannelsReq.builder().build();
        JsonResponse<GetDeviceChannelsResp> getDeviceChannelsResp = wvpProxyClient.getDeviceChannels(token, deviceId, getDeviceChannelsReq);
        log.info("{}", getDeviceChannelsResp);

        getDeviceChannelsResp.getData().getList().forEach(item -> {
            log.info("{}", item);
        });
    }
}
